Version 4.11 (11/10/2022)
* Fixed a NullPointerException associated which occurs when not using a custom tenantID (for Office365)

Version 4.1 (11/3/2022)
* Added support for MacOS Ventura

Version 4.024506 (2/3/2022)
* Added the ability to specify the region when using EmailConnectAmazon

Version 4.02307 (6/29/2021)
* Added function EmailGoogleConnect and EmailOffice365Connect, which will connect to both IMAP and SMTP servers.  This resolves an issue where messages sent using SMTP could not be moved into the IMAP Sent folder after sending.

Version 4.02306 (6/29/2021)
* EmailSend would by default show a progress bar as a plugin function, but not as a script step.  Resolved this discrepancy by defaulting to no progress bar for either.  

Version 4.02305 (6/25/2021)
* Added support for Apple M1 Architecture

Version 4.018 (4/23/2021)
* Refactored some examples in the demo file

Version 4.01 (3/24/2021)
* Added better error reporting to some demo file scripts

Version 4.0 (3/24/2021)
* Added the ability to initiate OAuth workflow, and fetch OAuth tokens from Google and Office 365
* OAuth tokens can now be used to connect to Google and Office 365 mail servers to send and receive mail
* Tokens can be silently refreshed using long-lived refresh tokens
* Resolved some issues parsing parameters

Version 3.34016 (12/10/2020)
* Resolved an issue where submitting a bug report would not include the log file

Version 3.34012 (11/2/2020)
* Fixed an issue where plugins were failing to load on FileMaker Server 19.1 and later

Version 3.316 (5/28/2020)
* Added "attachmentsDir" parameter to EmailReadMessages, allowing users to specify a local directory where they want attachments downloaded.
* Downloaded attachments are now deleted when EmailDisconnect is called
* Implemented a fix for some rare DHC issues that were occurring
* Fixed an issue where inline attachments were sometimes not properly downloaded
* Reworked the "secureconnection" parameter.  SecureConnection will now set both ssl and tls to true.  However these can be set individually with "ssl=true" or "tls=true".  This resolves issues with certain mail servers that require tls, but reject ssl
* Fixed an issue with IMAP servers that failed to retrieve the messageId
* Fixed the "unable to load BODYSRUCTURE" issue with some IMAP servers


Version 3.3 (11/20/2019)
* Fixed issues with the registration dialog where registration would not persist
* Plugins are now notarized to comply with MacOS Catalina changes
* Improved logging, preventing hangups on background logging threads
* Better handling of child processes on Windows

Version 3.2 (5/14/2019)
* Plugin startup and shutdown procedures have been greatly improved.  
* Fixed issues that caused PSOS calls to return "Host capacity exceeded"
* Fixed issues that prevented plugins from autoupdating using the Install Plugin script step
* Fixed an issue where multiple server side scripts would cause plugin functions to time out
* Fixed issues related to multi user environments (Server side scripts, WebDirect, Custom Web Publishing)
* Fixed issues where child processes would not be terminated on shutdown
* Reworked GUI framework, so that plugin windows will stay in lock-step with FileMaker windows
* Fixed issue related to multipart emails with attachments and no body being parsed incorrectly

Version 3.1 (6/14/2018)
* Fixed a problem that caused some plug-ins installed in FMS 17 on Windows to not initialize
* New feature: Added EmailSMSSend function for sending SMS/text messages using Amazon AWS credentials
* Fixed an issue parsing timestamps that could affect users who share databases across countries with different locale formats

Version 3.08 (1/21/2018)
* Fixed a problem where plug-ins that had just been installed on Windows would not initialize if Internet Security options were set to 'high'
* Fixed an issue where paraemters to EmailReadMessageValue were being treated as case-sensitive, now ignores upper and lower case
* Fixed an error reading dates on incoming messages
* Remove AOL Instant Messenger support (this service has been discontinued by Yahoo)
* Removing these libraries considerably shrinks the size of the e-mail plug-in, for instance the Mac plugin shrank from 18.6 megabytes to 6.3 megabytes.

Version 3.06 (12/6/2017)
* Now compatible with MacOS High Sierra
* License checking code has been improved - fixed several issues related to license checking
* Graphical User Interface (GUI) improvements made to progress bars, file choosers, and configuration dialog windows
* Better reliability when loading and initializing plug-ins

Version 3.05 (6/6/2017)
* Fixed cases where server-side scripts could cause the FileMaker Scripting Engine to hang
* Fixed some issues with FileMaker Cloud when enabling and disabling plug-ins repeatedly
* Fixed some problems on Mac displaying configuration dialog
* Fixed an issue for maintenance customers getting an incorrect message that their license was expired
* Restored compatibility for 32-bit Windows OS

Version 3.04 (5/27/2017)
* Many bug fixes, especially for GUI operations, server-side operations, and running multiple plug-ins

Version 3.02 (5/12/2017)
* Fixed an issue that prevented plug-ins from loading in Windows Server 2012r2

Version 3.01 (5/10/2017)
* No longer requires Java installation
* Can use plugin functions as script steps with a user-friendly GUI for specifying parameters
* Better error reporting in scripts
* Compatible with FileMaker Cloud
* Better compatibility with FileMaker Server for Perform Script on Server and scheduled scripts
* Each plugin runs in a separate process, increasing reliability and stability
* Plugins can be reliably unloaded, making it possible to auto-update without restarting FileMaker
* Where appropriate, plugin parameters can be selected from pull-down lists and checkboxes
* Support for streaming large container data, allowing unlimited amounts of data to be transferred between FileMaker and the plugin without running out of memory.
* Compatible with the older plugin API, so you can continue to use your existing scripts and calculations with the new plugins.
* Created an optional parameter with EmailReadAttachment to save the attachment in a specified folder outside filemaker as opposed to a container field
* Added an option to EmailModel to enable SASL authentication mechanisms, specifically CRAM-MD5. Useful when PLAIN auth is disabled for all connection protocols
* Added an option to EmailModel for disabling all IMAP/SMTP authentication settings, used by passing a flag with EmailConnectIMAP or EmailConnectSMTP called enableLegacyLogin
* Added an option to EmailModel to enable javamail logging, currently only enabled with EmailConnectIMAP
* EmailAttachFile now checks for compressed container fields and decompresses them
* Fixed EmailAttachFile when a directory is passed to be zipped
* Save attachments in the correct folders when run on FM Server
* Reference EmailAttachFile doc from EmailQuickSend to provide information on possible attachment URI schemes

Version 2.17 (3/23/2016)
* Fixed outbound e-mail sending via Amazon Simple Email Sending (SES) Service

Version 2.14 (9/18/2015)
* fixed issue with EmailRegister

Version 2.13 (8/5/2015)
* fixed issue with EmailConnectAmazon

Version 2.12 (5/12/2015)
* FileMaker 14 compatibility release
* Updates to usage with PSOS and server scheduled scripts
* Updates to install plugin and auto-update

Version 2.11 (12/15/2014)
* Full support for Perform Script on Server (PSOS), FileMaker Server 13 feature
* 64-bit support for all plugin deployments
* Support for Windows Server 2012
* When sending messages via Amazon SES (Simple Email Service), e-mail plugin breaks mass list into single recipients. This is Amazon's recommendation for sending bulk e-mail messages.
* Retries messages sent via Amazon SES if they exceed the maximum sending rate.
* added EmailGetMessageCount to get message count in a mailbox

Version 2.031
* Speed increase for downloading attachments from IMAP server

Version 2.03
* When reading an email with an embedded message, that message is written out as a encapsulated_message.eml attachment. Use EmailReadMessageFromFile to parse this nested message.
* Fix for date headers containing newlines.

Version 2.027
.emlx fixes for EmailReadMessagesFromFile

Version 2.022
* Fix for timeouts not being used when ssl=true

Version 2.021
* Support for reading .emlx files using EmailReadMessagesFromFile
* Fixed "forceTrust=true" when connecting to SMTP servers over SSL
* Inline attachments are now given a filename header
* Fixed a bug when reading some base64-encoded messages


Version 2.02 (12/13/2013)
* Fixed error when recipient was empty when calling EmailCreate

Version 2.01 (10/29/2013)
* POP Servers more reliably remove messages flagged as "deleted"
* EmailSetMessageFlag values default to "true" if omitted

Version 2.0 (10/17/2013)
* Send email using Amazon Simple Email Service and Email 2
* Send Instant Messages and SMS / text messages using AIM
* Move messages on IMAP servers, or save copies of outgoing messages with new function EmailMoveCurrentMessage
* Support for POP3 UID reading & searching: A much more efficient way to get new messages from your POP3 and IMAP mailboxes
* Support for manually specifying message-id for outgoing messages
* Customizable progress bar
* Added EmailReadMessagesFromFile, for pulling messages from an MBOX file or MimeMessage raw file
* Automatically zips directories sent as attachments for you
* Option to remove deleted messages immediately with IMAP mailboxes
* Now gives you the capability to specify multiple plain text parts in a single message
* Improved support for messages containing both inline and non-inline attachments
* Now supports CRAM-MD5 authentication when connecting to an SMTP server
* Default timeout of 30 seconds for all network activity
* Better decoding of encoded filenames in non-US locales
* Better support for messages containing both inline and non-inline attachments
* Call EmailerConnect... methods with an extra "forceTrust=true" to trust troublesome (self-signed) SSL certificates
* Call EmailerConnect... methods with an extra "tls=true" to explicitly enable STARTTLS mode
* Call EmailReadMessageValue("raw") to get the raw message data
* 64-bit plugin now included for use with Custom Web Publishing in FMS 12
* New error reporting features in plugin
* Compatible with Java 7 update 45
* Bug Fixes and improvements

Important Changes from 1.0
* EmailReadMessages downloads attachments by default! Use "attachments=false" for version 1 behavior.
* Messages flagged for deletion are not fetched by default. You can fetch these by passing "deleted=true" or "deleted=any" when calling EmailReadMessages
* Instead of EmailConnect, use one of: EmailConnectSMTP, EmailConnectPOP, EmailConnectIMAP

Version 1.81 (12/9/2008)
* Fixed bug when retrieving IMAP messages by a uid range
* Fixed documentation on retrieving IMAP messages by uid
* Correctly appends plain-text attachments instead of using them as the message body

Version 1.8 (11/19/2008)
* Email subjects use UTF-8 Unicode encoding, fixing some issues with curly quotes, currency symbols in subject lines.

Version 1.791 (11/12/2008)
* Fix for applets when using Java 1.6_10

Version 1.79 (11/6/2008)
* Fixed memory-related crash when sending very large email bodies from IWP

Version 1.78 (10/30/2008)
* Fixed multiple calls to EmailBodySubstitute not working correctly.

Version 1.779 (10/27/2008)
* Bug fix for attachments which have empty filenames

Version 1.778 (10/3/2008)
* No longer requires a demo license to run in demo mode

Version 1.777 (9/15/2008)
* Additional fix for escaping backslashes in EmailBodySubstitute

Version 1.776 (9/10/2008)
* EmailBodySubstitute arguments can contain reserved characters like $^&[] now.

Version 1.775 (8/25/2008)
* Additional unicode fixes
* Improved stability on progress dialogs during reading mail
* Merge field data can contain $ symbols now

Version 1.773 (8/22/2008)
* Fixed a problem that could sometimes prevent the email plugin from loading on the server in Windows.

Version 1.77 (8/21/2008)
* Fixed numerous unicode character encoding issues when reading messages from the server.
* Fixed incoming emails missing HTML body parts in some cases/locales.

Version 1.76 (8/5/2008)
* Better support for fetching invalid messages from the server: the valid parts are returned, invalid addresses, etc. are omitted.

Version 1.75 (7/30/2008)
* Added EmailOutgoingMessageId function. This is useful for doing your own threading based on outgoing message-id headers.

Version 1.74 (7/24/2008)
* Added IMAP support for searching by message UID.  This is the preferred way to fetch new messages from an IMAP mailbox.
* Timestamps returned from EmailReadMessageValue("date") are formatted based on the current locale

Version 1.735 (7/21/2008)
* Better support for .mhtml files, strips leading characters from HTML and handles .mht file extensions

Version 1.732 (7/3/2008)
* Ignores any OS X applefile attachments for incoming email
* Correctly strips quote marks from attachments which are loaded from a URL

Version 1.731 (7/1/2008)
* Support for .mhtml messages using the EmailSetBodyFile function
* POP accounts default to read-write (not read-only).  Better error checking when trying to modify messages in a read-only mailbox.

Version 1.72b (6/16/2008)
* Fallback mechanism when reading badly formatted messages from a server. If an invalid message is encountered, an error is logged and the message is skipped.

Version 1.72 (6/3/2008)
* Support for getting all message headers for an incoming message using EmailReadMessageValue("headers")
* Support for getting individual message headers for an incoming message using EmailReadMessageValue("header:X-Mailer")
* Fixed bug intrdouced in version 1.71 regarding plaintext message sending
* Improved startup time, fixed an issue with the splash screen hanging
* New log file location

Version 1.71 (5/30/2008)
* EmailSetBodyFile function added: load a message body from an HTML file, optionally creating inline attachments for all linked resources
* EmailBodySubstitute function added: change some text in your HTML message body, without needing to re-create the entire message
* Fixes related to modifying the structure of an email message and re-sending it.

Version 1.7 (5/20/2008)
* SSL Support (you can now send & receive from GMail)
* Multipart support: send HTML messages with a plaintext alternative by calling EmailSetBody() multiple times with different content types.
* Send HTML emails with embedded attachments using EmailAttachFileInline()

Version 1.63 (4/11/2008)
* Better Leopard compatibility when running with multiple 360Works plugins

Version 1.622
* Allow empty subjects in sent messages

Version 1.6 (3/24/2008)
* Greatly improved support for reading email messages from server
* Cancellable progress bar when downloading messages
* Read HTML email content from the server
* Modify email messages on POP/IMAP servers
* Added EmailClient.fp7 example file, and new example file
* API Changes for reading email messages from server (multiple connect methods, no more protocol parameters)
* Removed deprecated EmailAttachContainer (use EmailAttachFile instead)
* Deprecated EmailConnect (use EmailConnectSMTP, EmailConnectPOP, EmailConnectIMAP instead)
* Method signature change for EmailReadMessages (no longer accepts a protocol parameter)
* Attachments now preserve filenames

Version 1.51 (2/22/2008)
* Major performance increases when reading messages from a server
* Addition of EmailReadAttachment function for importing attachment data
* Attachment download setting now defaults to false
* Better recovery when encountering messages with invalid parts

Version 1.5 (2/20/2008)
* Fixed a problem when sending mail in the Web Publishing Engine on Windows
* Support for reading mail one message at a time (for operations on the server which can't use [Import XML])

Version 1.45 (2/13/2008)
* Fixed serious bug in email import feature. Now uses default ports to connect to IMAP or POP servers.

Version 1.4
* Better compatibility with multiple 360Works plugins running in Leopard.
* Fixed memory leaks.
* Improvements to stability, especially when running in IWP

Version 1.38
* Better fix for the error "No object DCH for MIME type multipart/mixed..." when sending email

Version 1.37
* Fix for the error "No object DCH for MIME type multipart/mixed..." when sending email

Version 1.32
* Support for reading messages and attachments from a networked mailbox
* Filter which messages get retrieved by date, sender, or many other parameters
* EmailAttachFile accepts container data now, in addition to URLs and paths
